QwtSyntheticPointData(3)

NAME
QwtSyntheticPointData -

SYNOPSIS

#include <qwt_series_data.h>

Inherits QwtSeriesData< QPointF >.

  Public Member Functions
QwtSyntheticPointData (size_t size, const QwtInterval &=QwtInterval())
virtual QRectF boundingRect () const
QwtInterval interval () const
QRectF rectOfInterest () const
virtual QPointF sample (size_t i) const
void setInterval (const QwtInterval &)
virtual void setRectOfInterest (const QRectF &)
void setSize (size_t size)
size_t size () const
virtual double x (uint index) const
virtual double y (double x) const =0

  Additional Inherited Members

Detailed Description

Synthetic point data. QwtSyntheticPointData provides a fixed number of points for an interval. The points are calculated in equidistant steps in x-direction.

If the interval is invalid, the points are calculated for the 'rect of interest', what normally is the displayed area on the plot canvas. In this mode you get different levels of detail, when zooming in/out.

Example

The following example shows how to implement a sinus curve.

#include <cmath>
#include <qwt_series_data.h>
#include <qwt_plot_curve.h>
#include <qwt_plot.h>
#include <qapplication.h>
class SinusData: public QwtSyntheticPointData
{
public:
    SinusData():
        QwtSyntheticPointData(100)
    {
    }
    virtual double y(double x) const
    {
        return qSin(x);
    }
};
int main(int argc, char **argv)
{
    QApplication a(argc, argv);
    QwtPlot plot;
    plot.setAxisScale(QwtPlot::xBottom, 0.0, 10.0);
    plot.setAxisScale(QwtPlot::yLeft, -1.0, 1.0);
    QwtPlotCurve *curve = new QwtPlotCurve("y = sin(x)");
    curve->setData(SinusData());
    curve->attach(&plot);
    plot.show();
    return a.exec();
}.fi

Constructor & Destructor Documentation

  QwtSyntheticPointData::QwtSyntheticPointData (size_tsize, const QwtInterval &interval = QwtInterval())
Constructor

Parameters:
    size Number of points
    interval Bounding interval for the points

See also:
    setInterval(), setSize()

Member Function Documentation

  QRectF QwtSyntheticPointData::boundingRect () const [virtual]

Calculate the bounding rect. This implementation iterates over all points, what could often be implemented much faster using the characteristics of the series. When there are many points it is recommended to overload and reimplement this method using the characteristics of the series ( if possible ).

Returns:
    Bounding rectangle

Implements QwtSeriesData< QPointF >.

  QwtInterval QwtSyntheticPointData::interval () const
Returns:
    Bounding interval

See also:
    setInterval(), size()

  QRectF QwtSyntheticPointData::rectOfInterest () const
Returns:

See also:
    setRectOfInterest()

  QPointF QwtSyntheticPointData::sample (size_tindex) const [virtual]
Calculate the point from an index

Parameters:
    index Index

Returns:
    QPointF(x(index), y(x(index)));

Warning:
    For invalid indices ( index < 0 || index >= size() ) (0, 0) is returned.

Implements QwtSeriesData< QPointF >.

  void QwtSyntheticPointData::setInterval (const QwtInterval &interval)
Set the bounding interval

Parameters:
    interval Interval

See also:
    interval(), setSize()

  void QwtSyntheticPointData::setRectOfInterest (const QRectF &rect) [virtual]
Set a the 'rect of interest'

QwtPlotSeriesItem defines the current area of the plot canvas as 'rect of interest' ( QwtPlotSeriesItem::updateScaleDiv() ).

If interval().isValid() == false the x values are calculated in the interval rect.left() -> rect.right().

See also:
    rectOfInterest()

Reimplemented from QwtSeriesData< QPointF >.

  void QwtSyntheticPointData::setSize (size_tsize)
Change the number of points

Parameters:
    size Number of points

See also:
    size(), setInterval()

  size_t QwtSyntheticPointData::size () const [virtual]
Returns:
    Number of points

See also:
    setSize(), interval()

Implements QwtSeriesData< QPointF >.

  double QwtSyntheticPointData::x (uintindex) const [virtual]
Calculate a x-value from an index

x values are calculated by deviding an interval into equidistant steps. If !interval().isValid() the interval is calculated from the 'rect of interest'.

See also:
    interval(), rectOfInterest(), y()

  virtual double QwtSyntheticPointData::y (doublex) const [pure virtual]
Calculate a y value for a x value

Parameters:
    x x value

Returns:
    Corresponding y value

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.